]> Dogcows Code - chaz/tar/blob - scripts/backup.sh.in
New file. Source for backup.sh
[chaz/tar] / scripts / backup.sh.in
1 #! /bin/sh
2 # This program is part of GNU tar
3 # Copyright 2004, Free Software Foundation
4 #
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 1, or (at your option)
8 # any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
18 # 02111-1307, USA.
19
20 PROGNAME=`basename $0`
21 CONFIGPATH="$SYSCONFDIR/backup"
22 REMOTEBACKUPDIR="$SYSCONFDIR/tar-backup"
23 CONFIGFILE=${CONFIGPATH}/backup-specs
24 DIRLIST=${CONFIGPATH}/dirs
25 FILELIST=${CONFIGPATH}/files
26 LOGPATH=${CONFIGPATH}/log
27
28 # Default functions for running various magnetic tape commands
29 mt_begin() {
30 mt -f "$1" retension
31 }
32
33 mt_rewind() {
34 mt -f "$1" rewind
35 }
36
37 mt_offline() {
38 mt -f "$1" offl
39 }
40
41 mt_status() {
42 mt -f "$1" status
43 }
44
45 # The main configuration file may override any of these variables
46 MT_BEGIN=mt_begin
47 MT_REWIND=mt_rewind
48 MT_OFFLINE=mt_offl
49 MT_STATUS=mt_status
50
51 # Insure `mail' is in PATH.
52 PATH="/usr/ucb:${PATH}"
53 export PATH
54 # Put startdate in the subject line of mailed report, since if it happens
55 # to run longer than 24 hours (as may be the case if someone forgets to put
56 # in the next volume of the tape in adequate time), the backup date won't
57 # appear too misleading.
58 startdate="`date`"
59 here="`pwd`"
60 # Save local hostname
61 localhost="`hostname | sed -e 's/\..*//' | tr A-Z a-z`"
62
63 # Produce a diagnostic output
64 message() {
65 if [ "$VERBOSE" != "" ]; then
66 if [ $VERBOSE -ge $1 ]; then
67 shift
68 echo "$@" >&2
69 fi
70 fi
71 }
72
73 # Bail out and exit.
74 bailout() {
75 echo "$PROGNAME: $*" >&2
76 exit 1
77 }
78
79 # Return current date
80 now() {
81 #IF_DATE_FORMAT_OK
82 date +%Y-%m-%d
83 #ELSE_DATE_FORMAT_OK
84 LC_ALL=C date | \
85 sed 's/[^ ]* *\([^ ]*\) *\([^ ]*\).* \([^ ]*\)$/\3-\1-\2/
86 /-[0-9]$/s/\([0-9]\)$/0\1/
87 /Jan/{s/Jan/01/p;q;}
88 /Feb/{s/Feb/02/p;q;}
89 /Mar/{s/Mar/03/p;q;}
90 /Apr/{s/Apr/04/p;q;}
91 /May/{s/May/05/p;q;}
92 /Jun/{s/Jun/06/p;q;}
93 /Jul/{s/Jul/07/p;q;}
94 /Aug/{s/Aug/08/p;q;}
95 /Sep/{s/Sep/09/p;q;}
96 /Oct/{s/Oct/10/p;q;}
97 /Nov/{s/Nov/11/p;q;}
98 /Dec/{s/Dec/12/p;q;}'
99 #ENDIF_DATE_FORMAT_OK
100 }
101
102 # Bail out if we don't have root privileges.
103 test_root() {
104 if [ ! -w ${ROOT_FS-/} ]; then
105 bailout "The backup must be run as root or else some files will fail to be dumped."
106 fi
107 }
108
109 advice() {
110 echo "Directory $1 is not found." >&2
111 cat >&2 <<EOF
112 The following directories and files are needed for the backup to function:
113
114 1. Directory with configuration files and file lists:
115 $CONFIGPATH
116 2. Directory for backup log files
117 $LOGPATH
118 3. Main configuration file
119 $CONFIGFILE
120
121 Please, create these and invoke the script again.
122 EOF
123 }
124
125 init_common() {
126 # Check if the necessary directories exist
127 if [ ! -d $CONFIGPATH ]; then
128 advice $CONFIGPATH
129 exit 1
130 fi
131 if [ ! -d $LOGPATH ]; then
132 if mkdir $LOGPATH; then
133 :
134 else
135 advice $LOGPATH
136 exit 1
137 fi
138 fi
139 # Get the values of BACKUP_DIRS, BACKUP_FILES, and other variables.
140 if [ ! -r $CONFIGFILE ]; then
141 echo "$PROGNAME: cannot read $CONFIGFILE. Stop." >&2
142 exit 1
143 fi
144 . $CONFIGFILE
145
146 # Environment sanity check
147
148 test_root
149
150 if [ x"${ADMINISTRATOR}" = x ]; then
151 bailout "ADMINISTRATOR not defined"
152 fi
153
154 [ x"$TAR" = x ] && TAR=tar
155 [ x"$SLEEP_TIME" = x ] && SLEEP_TIME=60
156
157 if [ x$VOLNO_FILE = x ]; then
158 bailout "VOLNO_FILE not specified"
159 fi
160
161 if [ -r $DIRLIST ]; then
162 BACKUP_DIRS="$BACKUP_DIRS `cat $DIRLIST`"
163 fi
164 if [ -r $FILELIST ]; then
165 BACKUP_FILES="$BACKUP_FILES `cat $FILELIST`"
166 fi
167
168 if [ \( x"$BACKUP_DIRS" = x \) -a \( x"$BACKUP_FILES" = x \) ]; then
169 bailout "Neither BACKUP_DIRS nor BACKUP_FILES specified"
170 fi
171 if [ "$RSH" = "" ]; then
172 RSH=rsh
173 fi
174 POSIXLY_CORRECT=1
175 export POSIXLY_CORRECT
176 }
177
178 init_backup() {
179 init_common
180 TAR_PART1="${TAR} -c --format=gnu --multi-volume --one-file-system --sparse --volno-file=${VOLNO_FILE}"
181 if [ "x$XLIST" != x ]; then
182 TAR_PART1="${TAR_PART1} \`test -r $REMOTEBACKUPDIR/$XLIST && echo \"--exclude-from $REMOTEBACKUPDIR/$XLIST\"\`"
183 fi
184 if [ "$RSH_COMMAND" != "" ]; then
185 TAR_PART1="${TAR_PART1} --rsh-command=$RSH_COMMAND"
186 fi
187 if [ x$BLOCKING != x ]; then
188 TAR_PART1="${TAR_PART1} --blocking=${BLOCKING}"
189 fi
190
191 # Only use --info-script if DUMP_REMIND_SCRIPT was defined in backup-specs
192 if [ "x${DUMP_REMIND_SCRIPT}" != "x" ]; then
193 TAR_PART1="${TAR_PART1} --info-script='${DUMP_REMIND_SCRIPT}'"
194 fi
195 # Set logfile name
196 # Logfile name should be in the form ``log-1993-03-18-level-0''
197 # They go in the directory `@sysconfdir@/log'.
198 # i.e. year-month-date. This format is useful for sorting by name, since
199 # logfiles are intentionally kept online for future reference.
200 LOGFILE="${LOGPATH}/log-`now`-level-${DUMP_LEVEL}"
201 }
202
203 init_restore() {
204 init_common
205 # FIXME: Replace --list with --extract
206 TAR_PART1="${TAR} --extract --multi-volume"
207 if [ "$RSH_COMMAND" != "" ]; then
208 TAR_PART1="${TAR_PART1} --rsh-command=$RSH_COMMAND"
209 fi
210 if [ x$BLOCKING != x ]; then
211 TAR_PART1="${TAR_PART1} --blocking=${BLOCKING}"
212 fi
213
214 # Only use --info-script if DUMP_REMIND_SCRIPT was defined in backup-specs
215 if [ "x${DUMP_REMIND_SCRIPT}" != "x" ]; then
216 TAR_PART1="${TAR_PART1} --info-script='${DUMP_REMIND_SCRIPT}'"
217 fi
218 LOGFILE="${LOGPATH}/restore-`now`"
219 }
220
221 wait_time() {
222 if [ "${1}" != "now" ]; then
223 if [ "${1}x" != "x" ]; then
224 spec="${1}"
225 else
226 spec="${BACKUP_HOUR}"
227 fi
228
229 pausetime="`date | awk -v spec=\"${spec}\" '
230 BEGIN {
231 split(spec, time, ":")
232 }
233 {
234 split($4, now, ":")
235 diff = 3600 * (time[1] - now[1]) + 60 * (time[2] - now[2]);
236 if (diff < 0)
237 diff += 3600 * 24
238 print diff
239 }'`"
240 clear
241 echo "${SLEEP_MESSAGE}"
242 sleep "${pausetime}"
243 fi
244 }
245
246 level_log_name() {
247 echo "$REMOTEBACKUPDIR/${1}.level-${2-$DUMP_LEVEL}"
248 }
249
250 # Prepare a temporary level logfile
251 # usage: make_level_log HOSTNAME
252 make_level_log() {
253 if [ "z${localhost}" != "z$1" ] ; then
254 $RSH "$1" mkdir $REMOTEBACKUPDIR > /dev/null 2>&1
255 $RSH "$1" rm -f `level_log_name temp`
256 else
257 mkdir $REMOTEBACKUPDIR > /dev/null 2>&1
258 rm -f `level_log_name temp`
259 fi
260 }
261
262 # Rename temporary log
263 # usage: flush_level_log HOSTNAME FSNAME
264 flush_level_log() {
265 message 10 "RENAME: `level_log_name temp` --> `level_log_name $2`"
266 if [ "z${localhost}" != "z$1" ] ; then
267 $RSH "$1" mv -f `level_log_name temp` "`level_log_name $2`"
268 else
269 mv -f `level_log_name temp` "`level_log_name $2`"
270 fi
271 }
272
273 # Return the timestamp of the last backup.
274 # usage: get_dump_time LEVEL
275 get_dump_time() {
276 ls -r ${LOGPATH}/log-*-level-$1 \
277 | head -1 \
278 | sed "s,.*log-\(.*\)-level-$1,\1,"
279 }
280
281 # Do actual backup on a host
282 # usage: backup_host HOSTNAME [TAR_ARGUMENTS]
283 backup_host() {
284 message 10 "ARGS: $@"
285 rhost=$1
286 shift
287 if [ "z${localhost}" != "z$rhost" ] ; then
288 $RSH "$rhost" ${TAR_PART1} -f "${localhost}:${TAPE_FILE}" $@
289 else
290 # Using `sh -c exec' causes nested quoting and shell substitution
291 # to be handled here in the same way rsh handles it.
292 CMD="exec ${TAR_PART1} -f \"${TAPE_FILE}\" $@"
293 message 10 "CMD: $CMD"
294 sh -c "$CMD"
295 message 10 "RC: $?"
296 fi
297 }
298
299 print_level() {
300 if [ ${1-$DUMP_LEVEL} -eq 0 ]; then
301 echo "Full"
302 else
303 echo "Level ${1-$DUMP_LEVEL}"
304 fi
305 }
306
307 prev_level() {
308 print_level `expr $DUMP_LEVEL - 1` | tr A-Z a-z
309 }
310
311 remote_run() {
312 rhost=$1
313 shift
314 message 10 "REMOTE $rhost: $@"
315 if [ "x$rhost" != "x${localhost}" ] ; then
316 $RSH "${rhost}" "$@"
317 else
318 $*
319 fi
320 }
321
322 license() {
323 cat - <<EOF
324 This program is part of GNU tar
325 Copyright 2004, Free Software Foundation
326
327 This program is free software; you can redistribute it and/or modify
328 it under the terms of the GNU General Public License as published by
329 the Free Software Foundation; either version 1, or (at your option)
330 any later version.
331
332 This program is distributed in the hope that it will be useful,
333 but WITHOUT ANY WARRANTY; without even the implied warranty of
334 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
335 GNU General Public License for more details.
336
337 You should have received a copy of the GNU General Public License
338 along with this program; if not, write to the Free Software
339 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
340 02111-1307, USA.
341 EOF
342 }
This page took 0.050244 seconds and 5 git commands to generate.